/*****************************************************************************
 Extended String Class

 IMPLEMENTATION

 Author: Dima V. Fedorov <mailto:dima@dimin.net> <http://www.dimin.net/>

 History:
   12/05/2005 23:38 - First creation

 Ver : 1
*****************************************************************************/

#include <stdarg.h>
#include <stdio.h>

#include "xstring.h"

xstring &xstring::sprintf(const char *fmt, ...)
{
  xstring result;
  char cbuf[MAX_STR_SIZE];

  va_list ap;
  va_start(ap, fmt);
#ifdef HAVE_SECURE_C  
  vsprintf_s((char *) cbuf, MAX_STR_SIZE, fmt, ap);
#else
  vsprintf((char *) cbuf, fmt, ap);
#endif
  result += cbuf;

  va_end(ap);
  *this = result;
  return *this;
}

xstring &xstring::saddf(const char *fmt, ...)
{
  xstring result;
  char cbuf[MAX_STR_SIZE];

  va_list ap;
  va_start(ap, fmt);

#ifdef HAVE_SECURE_C  
  vsprintf_s((char *) cbuf, MAX_STR_SIZE, fmt, ap);
#else
  vsprintf((char *) cbuf, fmt, ap);
#endif
  result += cbuf;

  va_end(ap);
  *this += result;
  return *this;
}

xstring &xstring::insertAfterLast(const char *p, const xstring &s)
{
  unsigned int sp = (unsigned int) this->rfind(p);
  if (sp == std::string::npos) 
  {
    *this += s;
    return *this;
  }

  this->insert(sp, s);
  return *this;
}

